commit 4b304e3d639e2921251bbbb03e458db921f6836d
Author: John David Anglin <danglin@gcc.gnu.org>
Date:   Sun Oct 24 19:55:25 2021

    Revise -mdisable-fpregs option and add new -msoft-mult option
    
    The behavior of the -mdisable-fpregs is confusing in that it doesn't
    disable the use of the floating-point registers in all situations.
    The -msoft-float disables the use of the floating-point registers in
    all situations.  The Linux kernel only needs to disable use of the
    xmpyu instruction to avoid using the floating-point registers.
    
    This change revises the -mdisable-fpregs option to disable the use of
    the floating-point registers in all situations.  It is now equivalent
    to the -msoft-float option.  A new -msoft-mult option is added to
    disable use of the xmpyu instruction.  The libgcc library can be
    compiled with the -msoft-mult option to avoid using hardware integer
    multiplication.
    
    2021-10-24  John David Anglin  <danglin@gcc.gnu.org>
    
    gcc/ChangeLog:
    
            * config/pa/pa-d.c (pa_d_handle_target_float_abi): Don't check
            TARGET_DISABLE_FPREGS.
            * config/pa/pa.c (fix_range): Use MASK_SOFT_FLOAT instead of
            MASK_DISABLE_FPREGS.
            (hppa_rtx_costs): Don't check TARGET_DISABLE_FPREGS.  Adjust
            cost of hardware integer multiplication.
            (pa_conditional_register_usage): Don't check TARGET_DISABLE_FPREGS.
            * config/pa/pa.h (INT14_OK_STRICT): Likewise.
            * config/pa/pa.md: Don't check TARGET_DISABLE_FPREGS. Check
            TARGET_SOFT_FLOAT in patterns that use xmpyu instruction.
            * config/pa/pa.opt (mdisable-fpregs): Change target mask to
            SOFT_FLOAT.  Revise comment.
            (msoft-float): New option.

diff --git a/gcc/config/pa/pa-d.c b/gcc/config/pa/pa-d.c
index 6802738e85b..14ef8cae343 100644
--- a/gcc/config/pa/pa-d.c
+++ b/gcc/config/pa/pa-d.c
@@ -47,7 +47,7 @@ pa_d_handle_target_float_abi (void)
 {
   const char *abi;
 
-  if (TARGET_DISABLE_FPREGS || TARGET_SOFT_FLOAT)
+  if (TARGET_SOFT_FLOAT)
     abi = "soft";
   else
     abi = "hard";
diff --git a/gcc/config/pa/pa.c b/gcc/config/pa/pa.c
index 87802ece7b9..67519636815 100644
--- a/gcc/config/pa/pa.c
+++ b/gcc/config/pa/pa.c
@@ -497,7 +497,7 @@ fix_range (const char *const_str)
       break;
 
   if (i > FP_REG_LAST)
-    target_flags |= MASK_DISABLE_FPREGS;
+    target_flags |= MASK_SOFT_FLOAT;
 }
 
 /* Implement the TARGET_OPTION_OVERRIDE hook.  */
@@ -1578,14 +1578,14 @@ hppa_rtx_costs (rtx x, machine_mode mode, int outer_code,
 	}
       else if (mode == DImode)
 	{
-	  if (TARGET_PA_11 && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT)
-	    *total = COSTS_N_INSNS (32);
+	  if (TARGET_PA_11 && !TARGET_SOFT_FLOAT && !TARGET_SOFT_MULT)
+	    *total = COSTS_N_INSNS (25);
 	  else
 	    *total = COSTS_N_INSNS (80);
 	}
       else
 	{
-	  if (TARGET_PA_11 && !TARGET_DISABLE_FPREGS && !TARGET_SOFT_FLOAT)
+	  if (TARGET_PA_11 && !TARGET_SOFT_FLOAT && !TARGET_SOFT_MULT)
 	    *total = COSTS_N_INSNS (8);
 	  else
 	    *total = COSTS_N_INSNS (20);
@@ -10629,7 +10629,7 @@ pa_conditional_register_usage (void)
       for (i = 33; i < 56; i += 2)
 	fixed_regs[i] = call_used_regs[i] = 1;
     }
-  if (TARGET_DISABLE_FPREGS || TARGET_SOFT_FLOAT)
+  if (TARGET_SOFT_FLOAT)
     {
       for (i = FP_REG_FIRST; i <= FP_REG_LAST; i++)
 	fixed_regs[i] = call_used_regs[i] = 1;
diff --git a/gcc/config/pa/pa.h b/gcc/config/pa/pa.h
index fbb96045a51..7a313d617b0 100644
--- a/gcc/config/pa/pa.h
+++ b/gcc/config/pa/pa.h
@@ -833,7 +833,6 @@ extern int may_call_alloca;
 
 #define INT14_OK_STRICT \
   (TARGET_SOFT_FLOAT                                                   \
-   || TARGET_DISABLE_FPREGS                                            \
    || (TARGET_PA_20 && !TARGET_ELF32))
 
 /* The macros REG_OK_FOR..._P assume that the arg is a REG rtx
diff --git a/gcc/config/pa/pa.opt b/gcc/config/pa/pa.opt
index 09660c47d88..47995f73e65 100644
--- a/gcc/config/pa/pa.opt
+++ b/gcc/config/pa/pa.opt
@@ -50,8 +50,8 @@ Target Var(TARGET_COHERENT_LDCW) Init(1)
 Use ldcw/ldcd coherent cache-control hint.
 
 mdisable-fpregs
-Target Mask(DISABLE_FPREGS)
-Disable FP regs.
+Target Mask(SOFT_FLOAT)
+Disable FP regs.  Equivalent to -msoft-float.
 
 mdisable-indexing
 Target Mask(DISABLE_INDEXING)
@@ -143,6 +143,10 @@ msoft-float
 Target Mask(SOFT_FLOAT)
 Use software floating point.
 
+msoft-mult
+Target Mask(SOFT_MULT)
+Use software integer multiplication.
+
 msnake
 Target RejectNegative
 Generate PA1.1 code.

